tao_idl(1)

NAME
tao_idl - Compile IDL sources for use with the ACE ORB (TAO)

SYNOPSIS
tao_idl [OPTION...] filename

DESCRIPTION
tao_idl is a program that is used to compile IDL source code. The IDL compiler generates 9 files from each .idl file, the file names are obtained by taking the IDL basename and appending C.h, C.inl, C.cpp, S.h, S.inl, S.cpp, S_T.h, S_T.inl, and S_T.cpp; the client stubs are declared in the C.h file, the skeletons in the S.h file. Please see the Options list on how to get different suffixes for these files. Both clients and servers should link against the object files for the stubs and skeletons, this is needed to transparently support collocated objects. The server skeleton can make use of different lookup strategies to match the incoming operation with the correct operation at the servant. Dynamic Hashing and Perfect Hashing are the two different operation lookup strategies that are currently supported in tao_idl. By default, tao_idl tries to use Perfect Hashing strategy. If supported and available, gperf generates the lookup methods for this strategy.

OPTIONS

-u  The compiler prints out the options that are given below and exits clean.

-V  the compiler printouts its version and exits

-Wb,option_list
    pass options to the backend

    skel_export_macro=macro_name The compiler will emit macro_name right after each class or extern keyword in the generated skeleton code (S files,) this is needed for Windows/NT that requires special directives to export symbols from DLLs, usually the definition is just a space on unix platforms.

    skel_export_include=include_path The compiler will generate code to include include_path at the top of the generated server header, this is usually a good place to define the server side export macro.

    stub_export_macro=macro_name The compiler will emit macro_name right after each class or extern keyword in the generated stub code, this is needed for Windows/NT that requires special directives to export symbols from DLLs, usually the definition is just a space on unix platforms.

    stub_export_include=include_path The compiler will generate code to include include_path at the top of the client header, this is usually a good place to define the export macro.

    export_macro=macro_name The compiler will emit macro_name right after each class or extern keyword, this is needed for Windows/NT that requires special directives to export symbols from DLLs, usually the definition is just a space on unix platforms.

    export_include=include_path The compiler will generate code to include include_path at the top of the client header, this is usually a good place to define the export macro.

    pch_include=include_path The compiler will generate code to include include_path at the top of all TAO IDL compiler generated files. This can be used with a precompiled header mechanism, such as those provided by Borland C++Builder or MSVC++.

-E  only invoke the preprocessor

-Wp,option_list
    pass options to the preprocessor

-Dmacro_definition
    passed to the preprocessor

-Umacro_name
    passed to the preprocessor

-Iinclude_path
    passed to the preprocessor

-Aassertion
    passed to the preprocessor

-Y  passed to the preprocessor

-H perfect_hash
    To specify the IDL compiler to generate skelton code that uses perfect hashed operation lookup strategy, which is the default strategy. Perfect hashing uses gperf program, to generate lookup methods.

-H dynamic_hash
    To specify the IDL compiler to generate skelton code that uses dynamic hashed operation lookup strategy.

-H binary_search
    To specify the IDL compiler to generate skelton code that uses binary search based operation lookup strategy.

-H linear_search
    To specify the IDL compiler to generate skelton code that uses linear search based operation lookup strategy.

-in To generate #include statements with <>'s for the standard include files (e.g. tao/corba.h) indicating them as non-changing files

-ic To generate #include statements with ""s for changing standard include files (e.g. tao/corba.h).

-g  To specify the path for the perfect hasing program (GPERF). Default is $ACE_ROOT/bin/gperf or whatever the ACE_GPERF macro was defined to be during compilation of TAO.

-o  To specify the output directory to IDL compiler as to where all the IDL-compiler-generated files are to be put. By default, all the files are put in the current directory from where tao_idl is called.

-hc Client's header file name ending. Default is "C.h".

-hs Server's header file name ending. Default is "S.h".

-hT Server's template header file name ending. Default is "S_T.h".

-cs Client stub's file name ending. Default is "C.cpp".

-ci Client inline file name ending. Default is "C.inl".

-ss Server skeleton file name ending. Default is "S.cpp".

-sT Server template skeleton file name ending. Default is "S_T.cpp".

-si Server inline skeleton file name ending. Default is "S.inl".

-st Server's template inline file name ending. Default is "S_T.inl".

-t  Temporary directory to be used by the IDL compiler. Default : Resolve ACE_DEFAULT_TEMP_DIR_ENV. If it is not defined, choose /tmp/.

-Cw Output a warning if two identifiers in the same scope differ in spelling only by case (default for now).

-Ce Output an error if two indentifiers in the same scope differ in spelling only by case. Default output is warning (for now). Since there is at least one OMG IDL file (sfp.idl, part of the AVStreams specification) that is inconsistent with its own spelling rule, we have made a warning the default output until the issue is resolved.

-Gc Generate stubs and skeletons using compiled marshaling.

-Gi Generate stubs and skeletons using interpretive marshaling (default for now).

-Gl For TAO Core developers only. Generate locality constrained interface implementation. This flag is not of general interests and should never be used by end-users.

-Gp Generated collocated stubs that use Thru_POA collocation strategy. (default)

-Gd Generated collocated stubs that use Direct collocation strategy.

-Gt Generate optimized TypeCodes (unimplemented as yet).

-Gv Generate code that supports Object-By-Value.

-GI Generate templates files for the servant implementation.

-GIh arg
    Servant implemenation header file name ending.

-GIs arg
    Servant implemenation skeleton file name ending.

-GIb arg
    Prefix to the implementation class names.

-GIe arg
    Suffix to the implementation class names.

-GIc arg
    Generate copy constructors in the servant implementation template files.

-Sa Suppress generation of the Any operators

-Sp Suppress generation of collocated stubs that use Thru_POA collocation strategy.

-Sd Suppress generation of collocated stubs that use Direct collocation strategy. (default)

-St Suppress generation of the TypeCodes

BUGS
None.

AUTHORS

    Carlos O'Ryan <coryan@cs.wustl.edu>

    Ossama Othman <othman@cs.wustl.edu> performed man page conversion from original HTML source

SEE ALSO
gperf(1)